diff --git a/lib/librte_eventdev/rte_event_eth_rx_adapter.h b/lib/librte_eventdev/rte_event_eth_rx_adapter.h
index cf23cde..176f8ca 100644
--- a/lib/librte_eventdev/rte_event_eth_rx_adapter.h
+++ b/lib/librte_eventdev/rte_event_eth_rx_adapter.h
@@ -173,6 +173,9 @@ struct rte_event_eth_rx_adapter_queue_conf {
 };
 
 /**
+ * @warning
+ * @b EXPERIMENTAL: this API may change without prior notice
+ *
  * A structure used to retrieve statistics for an eth rx adapter instance.
  */
 struct rte_event_eth_rx_adapter_stats {
@@ -201,6 +204,9 @@ struct rte_event_eth_rx_adapter_stats {
 };
 
 /**
+ * @warning
+ * @b EXPERIMENTAL: this API may change without prior notice
+ *
  * Callback function invoked by the SW adapter before it continues
  * to process packets. The callback is passed the size of the enqueue
  * buffer in the SW adapter and the occupancy of the buffer. The
@@ -392,6 +398,9 @@ int rte_event_eth_rx_adapter_queue_del(uint8_t id, uint16_t eth_dev_id,
 int rte_event_eth_rx_adapter_stop(uint8_t id);
 
 /**
+ * @warning
+ * @b EXPERIMENTAL: this API may change without prior notice
+ *
  * Retrieve statistics for an adapter
  *
  * @param id
@@ -404,7 +413,8 @@ int rte_event_eth_rx_adapter_queue_del(uint8_t id, uint16_t eth_dev_id,
  *  - 0: Success, retrieved successfully.
  *  - <0: Error code on failure.
  */
-int rte_event_eth_rx_adapter_stats_get(uint8_t id,
+int __rte_experimental
+rte_event_eth_rx_adapter_stats_get(uint8_t id,
 				struct rte_event_eth_rx_adapter_stats *stats);
 
 /**
@@ -437,6 +447,9 @@ int rte_event_eth_rx_adapter_stats_get(uint8_t id,
 int rte_event_eth_rx_adapter_service_id_get(uint8_t id, uint32_t *service_id);
 
 /**
+ * @warning
+ * @b EXPERIMENTAL: this API may change without prior notice
+ *
  * Register callback to process Rx packets, this is supported for
  * SW based packet transfers.
  * @see rte_event_eth_rx_cb_fn
@@ -453,7 +466,7 @@ int rte_event_eth_rx_adapter_stats_get(uint8_t id,
  *  - 0: Success
  *  - <0: Error code on failure.
  */
-int
+int __rte_experimental
 rte_event_eth_rx_adapter_cb_register(uint8_t id,
 				uint16_t eth_dev_id,
 				rte_event_eth_rx_adapter_cb_fn cb_fn,
diff --git a/lib/librte_eventdev/rte_event_eth_rx_adapter.c b/lib/librte_eventdev/rte_event_eth_rx_adapter.c
index 8d178be..27e0fe7 100644
--- a/lib/librte_eventdev/rte_event_eth_rx_adapter.c
+++ b/lib/librte_eventdev/rte_event_eth_rx_adapter.c
@@ -2296,7 +2296,7 @@ static int rxa_sw_add(struct rte_event_eth_rx_adapter *rx_adapter,
 	return rxa_ctrl(id, 0);
 }
 
-int
+int __rte_experimental
 rte_event_eth_rx_adapter_stats_get(uint8_t id,
 			       struct rte_event_eth_rx_adapter_stats *stats)
 {
@@ -2383,10 +2383,11 @@ static int rxa_sw_add(struct rte_event_eth_rx_adapter *rx_adapter,
 	return rx_adapter->service_inited ? 0 : -ESRCH;
 }
 
-int rte_event_eth_rx_adapter_cb_register(uint8_t id,
-					uint16_t eth_dev_id,
-					rte_event_eth_rx_adapter_cb_fn cb_fn,
-					void *cb_arg)
+int __rte_experimental
+rte_event_eth_rx_adapter_cb_register(uint8_t id,
+				uint16_t eth_dev_id,
+				rte_event_eth_rx_adapter_cb_fn cb_fn,
+				void *cb_arg)
 {
 	struct rte_event_eth_rx_adapter *rx_adapter;
 	struct eth_device_info *dev_info;
diff --git a/lib/librte_eventdev/rte_eventdev_version.map b/lib/librte_eventdev/rte_eventdev_version.map
index 88c3ce5..95fd089 100644
--- a/lib/librte_eventdev/rte_eventdev_version.map
+++ b/lib/librte_eventdev/rte_eventdev_version.map
@@ -63,7 +63,6 @@ DPDK_17.11 {
 	rte_event_eth_rx_adapter_queue_del;
 	rte_event_eth_rx_adapter_service_id_get;
 	rte_event_eth_rx_adapter_start;
-	rte_event_eth_rx_adapter_stats_get;
 	rte_event_eth_rx_adapter_stats_reset;
 	rte_event_eth_rx_adapter_stop;
 } DPDK_17.08;
@@ -95,7 +94,6 @@ DPDK_19.05 {
 	rte_event_crypto_adapter_stats_get;
 	rte_event_crypto_adapter_stats_reset;
 	rte_event_crypto_adapter_stop;
-	rte_event_eth_rx_adapter_cb_register;
 	rte_event_port_unlinks_in_progress;
 	rte_event_eth_tx_adapter_caps_get;
 	rte_event_eth_tx_adapter_create;
@@ -124,3 +122,10 @@ DPDK_19.05 {
 	rte_event_timer_arm_tmo_tick_burst;
 	rte_event_timer_cancel_burst;
 } DPDK_18.05;
+
+EXPERIMENTAL {
+	global:
+
+	rte_event_eth_rx_adapter_cb_register;
+	rte_event_eth_rx_adapter_stats_get;
+};
diff --git a/MAINTAINERS b/MAINTAINERS
index 4493aa6..59192bc 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -398,7 +398,7 @@ F: lib/librte_eventdev/
 F: drivers/event/skeleton/
 F: app/test/test_eventdev.c
 
-Eventdev Ethdev Rx Adapter API
+Eventdev Ethdev Rx Adapter API - EXPERIMENTAL
 M: Nikhil Rao <nikhil.rao@intel.com>
 T: git://dpdk.org/next/dpdk-next-eventdev
 F: lib/librte_eventdev/*eth_rx_adapter*